//+------------------------------------------------------------------+
//|                                                         OsMA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"

//
//
//
//
//

#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Silver
#property  indicator_width1  2

//
//
//
//
//

extern int FastEMA   = 12;
extern int SlowEMA   = 26;
extern int SignalSMA = 9;

//
//
//
//
//

double OsmaBuffer[];
double MacdBuffer[];
double SignalBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {

   IndicatorBuffers(3);
   IndicatorDigits(Digits+2);
   SetIndexBuffer(0,OsmaBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,MacdBuffer);
   SetIndexBuffer(2,SignalBuffer);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName("OsMA("+FastEMA+","+SlowEMA+","+SignalSMA+")");

   return(0);
  }
  
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) MacdBuffer[i]   = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=limit; i>=0; i--) SignalBuffer[i] = iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
   
   //
   //
   //
   //
   //
   for(i=limit; i>=0; i--)   
   {
      OsmaBuffer[i]=MacdBuffer[i]-SignalBuffer[i];
      
      //
      //
      //
      //
      //
      
      }
      
   return(0);
  }
//+------------------------------------------------------------------+

